//: C08:RTTIandMultipleInheritance.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
#include <iostream>
#include <typeinfo>
using namespace std;

class BB {
public:
  virtual void f() {}
  virtual ~BB() {}
};

class B1 : virtual public BB {};
class B2 : virtual public BB {};
class MI : public B1, public B2 {};

int main() {
  BB* bbp = new MI; // Přetypování nahoru
  // Určení správného jména:
  cout << typeid(*bbp).name() << endl;
  // Dynamic_cast funguje správně:
  MI* mip = dynamic_cast<MI*>(bbp);
  // Nelze použít přetypování ve starém stylu:
//! MI* mip2 = (MI*)bbp; // Chyba při překladu
} ///:~
